'''
Author: your name
Date: 2021-04-14 14:12:18
LastEditTime: 2021-06-22 13:38:34
LastEditors: Please set LastEditors
Description: In User Settings Edit
FilePath: \evm-store\backend\controller\api_manager.py
'''
#!/usr/bin/env python
# -*- coding: utf_8 -*-

import os
import time
import json
import logging
import traceback
import subprocess
import uuid
from datetime import datetime

from pony.orm import *
from app.setting import config
from model.user import User
from utils import md5_salt
from utils.ccode import convert_string

logger = logging.getLogger("ApiManager")

class ApiManager(object):
    def __init__(self):
        super(ApiManager, self).__init__()

    def update_user_password(self, user, data):
        with db_session:
            editor = User.get(id=user)
            if not editor:
                return False, "current user is not exists"

            result = User.get(uuid=data.get("uuid"), password=md5_salt(data['password']))

            if not result:
                return None, "user does not exists"

            data.pop("uuid")
            data['password'] = md5_salt(data['newPassword'])
            data.pop('newPassword')
            data.update({
                "create_by": editor.id,
                "create_at": datetime.now(),
                "update_by": editor.id,
                "update_at": datetime.now()
            })

            result = result.set(**data)
            commit()

            return True, "success"

    def get_escape_text(self, data):
        return convert_string(data['string'])

    def opqcp(self, params):
        target_file = os.path.normpath(os.sep.join([config.get("UPLOAD_PATH"), params.get("filename")]))
        print("--------->", params, target_file)
        print(os.stat(target_file))

        # dtNowString = datetime.now().strftime("%Y%m%d%H%M%S%f")
        # fn, ex = os.path.splitext(params.get("filename"))

        output_path = os.path.dirname(target_file)

        print("#######", output_path)

        # command = ["./opqcp", target_file, output_path]
        
        # ret = subprocess.run(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, encoding="utf-8", timeout=5)
        # if ret.returncode == 0:
        #     print("success:", ret)
        # else:
        #     print("error:", ret)

        ret = target_file

        return True, ret

apiManager = ApiManager()
